## Общая структура GPIO драйвера

```
    ┌───────────────────────────┐
    │                           │
    │        Устройство         │
    │                           │
    └─────────────▴─────────────┘
                  │
    ┌─────────────┴─────────────┐                       ┌───────────────────────────┐
    │                           │                       │                           │
    │     Драйвер (gpio-*)      ◂───▸ /dev/gpio ◂── * ──┤   Клиентское приложение   │
    │                           │                       │                           │
    └───────────────────────────┘                       └───────────────────────────┘
```



## Дерево исходных кодов

```
|- hardware/gpio/am35/
|  |- *.*               - Исходный код GPIO-драйвера для TI AM3517
|  |- common.mk         - Параметры сборки драйверов
|  `- Makefile          - Правила сборки дерева исходников
|
|- utils/gpio-ctrl/     - Исходный код типового клиентского приложения GPIO-драйвера
|
`- Makefile             - Правила сборки дерева исходников
```



## Сборка драйвера

- Установить и настроить [комплект разработчика](https://help.kpda.ru/neutrino/2020/help/topic/ru.kpda.doc.dev_tools_ru/html/devkit/devkit.html) для [ЗОСРВ "Нейтрино" редакции 2020](https://help.kpda.ru/neutrino/2020/help/index.jsp).
- Выполнить команду:

```
make
```



## Запуск драйвера и обращение к нему

Общая схема запуска драйвера:

```
gpio-am35 &
```

Пример вызова клиентской утилиты:

```
gpio-ctrl -n /dev/gpio -p3 -d0 -o1
```

