/*
 * (c) 2017, SWD Embedded Systems Limited, http://www.kpda.ru
 */


#ifndef _PROTO_H_INCLUDED
#define _PROTO_H_INCLUDED


#define PRINT_FUNCTIONNAME

struct gpio_dev;
struct gpio_ocb;

#define IOFUNC_ATTR_T           struct gpio_dev
#define IOFUNC_OCB_T            struct gpio_ocb
#define THREAD_POOL_PARAM_T     dispatch_context_t

#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <stdint.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <stdarg.h>
#include <hw/inout.h>
#include <sys/iofunc.h>
#include <sys/dispatch.h>
#include <devctl.h>
#include <atomic.h>
#include <sys/neutrino.h>
#include <sys/procmgr.h>
#include <sys/mman.h>
#include <time.h>
#include <sys/slog.h>

#include <arm/omap3530.h>
#include <hw/gpio_am35.h>

#define _SLOGC_GPIO             40


typedef struct gpio_dev {
    iofunc_attr_t       hdr;
    dispatch_t          *dpp;
    dispatch_context_t  *ctp;
    int                 id;
    iofunc_notify_t     notify[3];
    void                *hdl;
} gpio_dev_t;

typedef struct gpio_ocb {
    iofunc_ocb_t        hdr;
} gpio_ocb_t;

typedef struct {
    uintptr_t           gpiobase[6];
} am35_gpio_t;

gpio_ocb_t *gpio_ocb_calloc( resmgr_context_t *ctp, gpio_dev_t *dev );
void gpio_ocb_free( gpio_ocb_t *ocb );
int gpio_devctl( resmgr_context_t *ctp, io_devctl_t *msg, gpio_ocb_t *ocb );
int gpio_slogf( const char *fmt, ... );

int hw_cmd_write( void *hdl, void *buf );
int hw_cmd_read( void *hdl, void *buf );
int hw_set_output( void *hdl, uint8_t data );
int hw_set_input( void *hdl, uint8_t data );
int hw_int_enable_wlevel( void *hdl, uint8_t data, uint8_t level );
int hw_int_enable( void *hdl, uint8_t data );
int hw_int_disable( void *hdl, uint8_t data );
int hw_irq_status( void *hdl, gpio_interrupt_t *gpio_int );


#endif
